<template>
  <div class="h-100">
    <div class="ob-accordion__item"
      v-for="group in domains"
      :key="group.uuid"
    >
      <div
        class="ob-accordion__title"
        @click="openAccordion(group)"
      >
        <i
          v-if="group._isOpen"
          class="icon chevron-up"
        />
        <i
          v-if="!group._isOpen"
          class="icon chevron-down"
        />
        <div class="ob-accordion__title-text">
          <div class="col-stat">
            <i class="icon blue ready-to-link"></i>
            {{ group.can_create_link_count }}
          </div>
          <div class="col-stat">
            <i class="icon blue link"></i>
            {{ group.link_count }}
          </div>
          <div class="col-stat">
            <i
              v-if="group.is_participant"
              class="icon blue home"
            />
          </div>
          <div class="col-title">{{ group.title }}</div>
        </div>
      </div>

      <div class="ob-accordion__content" v-show="group._isOpen">
        <link-browser-detail
          :source="group.links"
          @select-link-org="selectLinkOrg($event, group)"
          :selected-entry="selected"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { dictionary } from "@/translations/ru/LinkBrowserPage";
/* eslint-disabled */
import LinkBrowserDetail from "./LinkBrowserDetail";

const mapRole = role_code => {
  if (role_code === "carrier" || role_code === "CARRIER") return "carrier";
  if (role_code === "moderator" || role_code === "MODERATOR")
    return "moderator";
  if (role_code === "expeditor" || role_code === "EXPEDITOR")
    return "domain-owner";
  if (role_code === "client" || role_code === "CLIENT") return "user";
};

const mapLinkType = connect => {
  if (connect.type === "link") {
    if (connect.is_public_by_me && connect.is_public_by_contragent)
      return "link-mutal";
    if (connect.is_public_by_me) return "link-right";
    if (connect.is_public_by_contragent) return "link-left";
    return "link";
  } else {
    return null;
  }
};
export default {
  name: "LinkBrowser",
  components: { LinkBrowserDetail },
  props: {
    api: {
      type: Object,
      default: () => {}
    },
    userData: {
      type: Object,
      default: () => {}
    }
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: "title"
        },
        {
          title: this.dictionaryRu.columns.home,
          key: "home"
        },
        {
          title: this.dictionaryRu.columns.linked,
          key: "linked"
        },
        {
          title: this.dictionaryRu.columns.canLink,
          key: "canLink"
        }
      ];
    }
  },
  data() {
    return {
      dictionaryRu: dictionary,
      domains: [],
      selected: {}
    };
  },
  mounted() {
    this.compileDomains();
  },
  methods: {
    compileDomains() {
      return this.api
        .getDomains()
        .then(({ data }) => {
          this.domains = data.map(domain => {
            domain.restriction = false;
            domain._isOpen = false;
            domain.links = [];
            this.api.getLinks(domain.uuid).then(({ data }) => {
              domain.links = data.map(link => {
                link.domain_uuid = link.uuid;
                link.link_uuid = link.connect.uuid;
                link.role = mapRole(link.role_code);
                link.docs = link.contract_count;
                link.link_type = mapLinkType(link.connect);
                link.public_restriction = false;
                link.public_pending = false;
                link.pending = false;
                link.restriction =
                  link.connect.type === "visibility" &&
                  !link.connect.can_create_link;
                if (link.connect.type !== "link") {
                  this.api.getRestriction(link.uuid).then(({ data }) => {
                    link.restriction = data.status === "no";
                  });
                  this.api
                    .checkIfPending(this.userData.contractor_uuid, link.uuid)
                    .then(({ data }) => {
                      link.pending = data.result === "exists";
                    });
                } else {
                  this.api
                    .getPublicRestriction(link.connect.uuid)
                    .then(({ data }) => {
                      link.public_restriction = data.status === "no";
                    });
                }
                this.api
                  .checkIfPendingPublic(
                    this.userData.contractor_uuid,
                    link.uuid
                  )
                  .then(({ data }) => {
                    link.public_pending = data.result === "exists";
                  });
                return link;
              });
            });
            return domain;
          });
        })
        .catch(e => {
          console.error(e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных"
          });
        });
    },
    selectLinkOrg(org, domain) {
      this.$emit("select-link-org", org, domain);
      this.selected = org;
    },
    openAccordion(group) {
      group._isOpen = !group._isOpen;
    }
  }
};
</script>

<style lang="scss">
.ob-accordion {
  display: flex;
  background: $background-white;
  flex-direction: column;
  width: 100%;

  &__header {
    display: flex;
    width: 100%;
    height: 40px;
    padding-left: 44px;
    border-bottom: 1px solid $lavender;

    &-item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      color: $shale-gray;
      font-size: 11px;
      line-height: 12px;
      font-variant: small-caps;
      text-transform: uppercase;
      flex-basis: 20%;

      &:nth-child(3) {
        flex-basis: 10%;
      }
      &:nth-child(4) {
        flex-basis: 50%;
      }
    }
  }
  &__item {
    display: flex;
    flex-direction: column;
    border-left: none;
    border-right: none;
  }
  &__title {
    padding: 14px 15px 14px 15px;
    color: $linkBrowser-ob-accordion-title_color;
    display: flex;
    cursor: pointer;
    font-size: 14px;
    border-bottom: 1px solid $lavender;

    &-text {
      margin-left: 15px;
      width: 100%;
    }
    .icon {
      font-size: 15px;
    }
    .col-stat {
      float: right;
      width: 60px;
    }
    .col-title {
      margin-right: 180px;
    }
  }

  &__content {
    &-table {
      width: 100%;
      &-row {
        display: flex;
        border-bottom: 1px solid $lavender;
        padding: 8px 0;
        padding-left: 44px;
        min-height: 40px;
      }
      &-cell {
        display: flex;
        flex-direction: column;
        justify-content: center;
        font-size: 14px;
        line-height: 20px;
        flex-basis: 20%;
        color: $color-text-base;
        &:nth-child(3) {
          flex-basis: 10%;
          align-items: center;
        }
        &:nth-child(4) {
          flex-basis: 50%;
          i {
            margin-left: 6px;
          }
        }
      }
    }
  }
}
</style>
